% Dynamic Macroeconomics
% Problem Set 1: Detrending (Question 3)
% Written by Christian Rhl
% This version: 29.10.2013

clc;        % Clear screen
clear all;  % Removes all variables, globals and functions
close all;  % Closes all open Matlab windows

% Read in data (GDP is stored in column B of the Excel sheet)
load('USMacrodata.mat');


% Take the logarithm
Y = USMacrodata.GDPC1;
y = log(USMacrodata.GDPC1);
T = length(Y);

% Plot original data
f = figure(1);                                                     %create a figure window
[ax, h1, h2] = plotyy(USMacrodata.Quarter, y, USMacrodata.Quarter, Y, 'plot'); 
title('US GDP: Logarithm and actual value');                      %give it a title
xlim(ax(1),[1947 2013]);
xlim(ax(2),[1947 2013]);
legend('Log', 'Natural')
filename = 'gdp1.jpg';
saveas(f, filename);
clear f

f = figure(2);                        %create a figure window
plot(USMacrodata.Quarter, y, 'LineWidth', 2.5);     %plot(x,y) generates a plot of x against y
title('US GDP');                      %give it a title
xlim([1947 2013]);                    %determines the range of the x-axis
filename = 'gdp2.jpg';
saveas(f, filename);
clear f

% HP Filter

lambda = [0, 800, 1600, 64000];     %vector with different values for lambda

hptrend = zeros(T, length(lambda));             %store the trend here
hpcycle = zeros(T, length(lambda));             %store the cycle here

for i = 1:1:length(lambda);                     %loop over all values of lambda

hptrend(:,i) = hpfilter(y,lambda(i));
hpcycle(:,i) = y - hptrend(:,i);

end

% Plot the HP trend and cycle
f = figure(3);
plot(USMacrodata.Quarter, hptrend, 'LineWidth', 2.5);
title('HP Trend');
legend('\lambda = 0', '\lambda = 800', '\lambda = 1600', '\lambda = 64000');
xlim([1947 2013]);
filename = 'gdp3.jpg';
saveas(f, filename);
clear f

f = figure(4);
plot(USMacrodata.Quarter, hpcycle, 'LineWidth', 2.5);
title('Cyclical Component');
legend('\lambda = 0', '\lambda = 800', '\lambda = 1600', '\lambda = 64000');
xlim([1959 2010]);
filename = 'gdp4.jpg';
saveas(f, filename);
clear f


